--load lbb
local bosstable = LibStub("LibBabble-Boss-3.0"):GetLookupTable()
-- Northrend beasts
local loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("northrendbeasts",
	bosstable["The Beasts of Northrend"],
	{
		healthtrack={[34796]=true,[35144]=true,[34799]=true,[34797]=true,[34800]=false},
		manatrack={},
		phases={["1"]=bosstable["Gormok the Impaler"],["2"]=bosstable["Jormungars"],["3"]=bosstable["Icehowl"]},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if sid == 34796 or did == 34796 then
				return true
			end
		end
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("1") TimerCreate("Enrage", "dtime", 15*60) end,
		["COMBAT_LOG_EVENT_UNFILTERED"] = function(...)
			if (select(2,...)) == "UNIT_DIED" then
				local did = tonumber((select(6,...)):sub(9,12),16)
				if did == 34796 then
					EnterPhase("2")
					TimerCreate("Jormungars killed", "ucount", 2)
				elseif (did == 35144 or did == 34799) then
					if TimerValue("Jormungars killed") == 1 then
						TimerKill("Jormungars killed")
						EnterPhase("3")
					else
						TimerSet("Jormungars killed", 1)
					end
				elseif (did == 34797) then
					DisableEncounter()
				end
			end
		end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["The Beasts of Northrend"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Lord Jaraxxus
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("jaraxxus",
	bosstable["Lord Jaraxxus"],
	{
		healthtrack={[34780]=true,[34815]=false,[34826]=false},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if sid == 34780 or did == 34780 then
				return true
			end
		end
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Lord Jaraxxus"].." failed: "..StatusSubscribe.locale[errorMsg])
end

--faction champs
local champs = {[34461]=true,[34458]=true,[34460]=true,[34451]=true,[34469]=true,[34459]=true,[34467]=true,[35610]=false,[34448]=true,[34468]=true,[34449]=true,[34465]=true,[34445]=true,[34471]=true,[34456]=true,[34466]=true,[34447]=true,[34473]=true,[34441]=true,[34472]=true,[34454]=true,[34463]=true,[34455]=true,[34470]=true,[34444]=true,[34474]=true,[34450]=true,[35465]=false,[34475]=true,[34453]=true}
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("factionchamps",
	bosstable["Faction Champions"],
	{
		healthtrack=champs,
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if (champs[sid] ~= nil) or (champs[did] ~= nil) then
				return true
			end
		end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)

if not loadSuccess then
	print("Load of "..bosstable["Faction Champions"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- twin valks
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("twinvalkyr",
	bosstable["The Twin Val'kyr"],
	{
		healthtrack={[34497]=true,[34496]=true},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if (sid == 34497) or (did == 34497) or (sid == 34496) or (did == 34496) then
				return true
			end
		end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["The Twin Val'kyr"].." failed: "..StatusSubscribe.locale[errorMsg])
end
-- an00b
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("anubarak_toc",
	bosstable["Anub'arak"],
	{
		healthtrack={[34564]=true,[34607]=false},
		manatrack={},
		phases={["1"]="Aboveground",["2"]="Burrow",["3"]="Leeching Swarm"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if (sid == 34564) or (did == 34564) then
				return true
			end
		end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("1") TimerCreate("Enrage", "dtime", 600) end,
		["COMBAT_LOG_EVENT_UNFILTERED"] = function(...)
			if (select(9,...)) == 67322 then
				EnterPhase("2")
				TimerCreate("Resurface", "dtime", 60)
			elseif (not IsInPhase("3")) (select(2,...)) == "SWING_DAMAGE" and tonumber((select(3,...)):sub(9,12),16) == 34564 then
				EnterPhase("1")
			elseif (select(10,...)) == (GetSpellInfo(68647)) then
				EnterPhase("3")
			end
		end,
	}
)
